// $Id: MMUtil.java,v 1.24 2003/06/30 21:59:32 linus Exp $
// Copyright (c) 1996-99 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation without fee, and without a written
// agreement is hereby granted, provided that the above copyright notice
// and this paragraph appear in all copies.  This software program and
// documentation are copyrighted by The Regents of the University of
// California. The software program and documentation are supplied "AS
// IS", without any accompanying services from The Regents. The Regents
// does not warrant that the operation of the program will be
// uninterrupted or error-free. The end-user understands that the program
// was developed for research purposes and is advised not to rely
// exclusively on the program for any reason.  IN NO EVENT SHALL THE
// UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
// SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
// ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
// THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
// PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT,
// UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

// File: MMUtil.java
// Classes: MMUtil
// Original Author: not known

// 3 Apr 2002: Jeremy Bennett (mail@jeremybennett.com). Extended to support
// the Extend and Include relationships.

// 8 Apr 2002: Jeremy Bennett (mail@jeremybennett.com). Extended to add
// buildExtensionPoint and getExtensionPoints methods for use cases.

// 16 Apr 2002: Jeremy Bennett (mail@jeremybennett.com). Extended to remove
// include and extend relationships when deleting a use case.


package org.argouml.uml;

import ru.novosoft.uml.*;
import ru.novosoft.uml.foundation.core.*;
import ru.novosoft.uml.foundation.data_types.*;
import ru.novosoft.uml.model_management.*;
import ru.novosoft.uml.foundation.extension_mechanisms.*;
import ru.novosoft.uml.behavior.use_cases.*;
import ru.novosoft.uml.behavior.collaborations.*;
import ru.novosoft.uml.behavior.state_machines.*;
import ru.novosoft.uml.behavior.common_behavior.*;

import java.util.*;

import org.apache.log4j.Category;
import org.argouml.model.uml.UmlFactory;

/** Class with utility methods. Now mostly outdated.
 * @stereotype utility
 */
public class MMUtil {

    Category cat = Category.getInstance(org.argouml.uml.MMUtil.class);

    public static MMUtil SINGLETON = new MMUtil();

    public static MModel STANDARDS;

    static {
	STANDARDS = UmlFactory.getFactory().getModelManagement().createModel();
	STANDARDS.setName("standard Elements");
	MStereotype realizationStereo =
	    UmlFactory.getFactory().getExtensionMechanisms().createStereotype();
	realizationStereo.setName("realize");
	STANDARDS.addOwnedElement(realizationStereo);

	MStereotype interfaceStereo =
	    UmlFactory.getFactory().getExtensionMechanisms().createStereotype();
	interfaceStereo.setName("interface");
	STANDARDS.addOwnedElement(interfaceStereo);
    }


    /**
     * This tag is set on elements that are generated by reference when
     * importing.
     * If it is set, then the critics could ignore those objects if they want.
     */
    public static final String GENERATED_TAG = "GeneratedFromImport";

    
    


    


    
    
    
}

