// $Id: PropPanelStateMachine.java,v 1.12 2003/06/29 23:50:12 linus Exp $
// Copyright (c) 1996-2003 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation without fee, and without a written
// agreement is hereby granted, provided that the above copyright notice
// and this paragraph appear in all copies.  This software program and
// documentation are copyrighted by The Regents of the University of
// California. The software program and documentation are supplied "AS
// IS", without any accompanying services from The Regents. The Regents
// does not warrant that the operation of the program will be
// uninterrupted or error-free. The end-user understands that the program
// was developed for research purposes and is advised not to rely
// exclusively on the program for any reason.  IN NO EVENT SHALL THE
// UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
// SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
// ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
// THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
// PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT,
// UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

// $Id: PropPanelStateMachine.java,v 1.12 2003/06/29 23:50:12 linus Exp $
package org.argouml.uml.ui.behavior.state_machines;

import javax.swing.JList;
import javax.swing.JScrollPane;

import org.argouml.application.api.Argo;

import org.argouml.swingext.Orientation;
import org.argouml.uml.ui.PropPanelButton;
import org.argouml.uml.ui.UMLComboBoxNavigator;
import org.argouml.uml.ui.UMLLinkedList;
import org.argouml.uml.ui.foundation.core.PropPanelModelElement;
import org.argouml.util.ConfigLoader;

/**
 * @since Dec 6, 2002
 * @author jaap.branderhorst@xs4all.nl
 */
public class PropPanelStateMachine extends PropPanelModelElement {


    /**
     * Constructor for PropPanelStateMachine.
     */
    public PropPanelStateMachine() {
        this("StateMachine", ConfigLoader.getTabPropsOrientation());
        
    }

    public PropPanelStateMachine(String name, Orientation orient ) {
        super(name, orient);
        initialize();
    }

    protected void initialize() {
	addField(Argo.localize("UMLMenu", "label.name"), getNameTextField());
        addField(Argo.localize("UMLMenu", "label.stereotype"), new UMLComboBoxNavigator(this, Argo.localize("UMLMenu", "tooltip.nav-stereo"), getStereotypeBox()));
        addField(Argo.localize("UMLMenu", "label.namespace"), getNamespaceScroll());

        // the context in which the statemachine resides
        JList contextList = new UMLLinkedList(new UMLStateMachineContextListModel());
        addField(Argo.localize("UMLMenu", "label.represented-modelelement"), new JScrollPane(contextList));

        // the top state
        JList topList = new UMLLinkedList(new UMLStateMachineTopListModel());
        addField(Argo.localize("UMLMenu", "label.top-state"), new JScrollPane(topList));

        addSeperator();

        // the transitions the statemachine has
        JList transitionList = new UMLLinkedList(new UMLStateMachineTransitionListModel());
        addField(Argo.localize("UMLMenu", "label.transition"), new JScrollPane(transitionList));

        // the submachinestates
        // maybe this should be a mutable linked list but that's for the future to decide
        JList submachineStateList = new UMLLinkedList(new UMLStateMachineSubmachineStateListModel());
        addField(Argo.localize("UMLMenu", "label.submachinestate"), new JScrollPane(submachineStateList));

        new PropPanelButton(this, buttonPanel, _navUpIcon,
                            Argo.localize("UMLMenu", "button.go-up"), "navigateNamespace",
                            null);
        new PropPanelButton(this, buttonPanel, _deleteIcon,
                            localize("Delete"), "removeElement",
                            null);
       

    }

}



